from Vehicle import Vehicle
from gui.Scaleform.daapi.view.battle.shared.damage_panel import DamagePanel

from xfw.events import registerEvent
from xfw_actionscript.python import *
from xvm_main.python.logger import *

health = 0
maxHealth = 0
dmg = None
vehicle = None


@registerEvent(DamagePanel, 'updateVehicleParams')
def updateVehicleParams(self, vehicle, _, __):
    global maxHealth, health
    maxHealth = health = self._maxHealth
    as_event('ON_MY_HP')


@registerEvent(DamagePanel, '_DamagePanel__onVehicleControlling')
def DamagePanel__onVehicleControlling(self, vehicle):
    global maxHealth, health
    maxHealth = health = self._maxHealth
    as_event('ON_MY_HP')


@registerEvent(Vehicle, 'onHealthChanged')
def onHealthChanged(self, newHealth, oldHealth, attackerID, attackReasonID):
    if self.isPlayerVehicle:
        global health, dmg
        health = max(0, newHealth)
        dmg = oldHealth - health
        as_event('ON_MY_HP')


@registerEvent(Vehicle, '_Vehicle__onAppearanceReady')
def _Vehicle__onAppearanceReady(self, appearance):
    global maxHealth, health, vehicle, dmg
    if self.isPlayerVehicle:
        vehicle = self
        dmg = None
        as_event('ON_MY_HP')


@xvm.export('my_hp.health', deterministic=False)
def my_hp_health(norm=None):
    if health is not None:
        if maxHealth != 0:
            return health if norm is None else int(norm * health // maxHealth)
        else:
            return health if norm is None else norm


@xvm.export('my_hp.maxHealth', deterministic=False)
def my_hp_maxHealth():
    return maxHealth


@xvm.export('my_hp.dmg', deterministic=False)
def my_hp_dmg():
    return dmg
